from card import Card

# You'll need the random module to shuffle the deck
import random

# Use these constant Lists to help you construct the Cards for your Deck
CARD_RANKS = ['2', '3', '4', '5', '6', '7', '8', '9', '10', 'J', 'Q', 'K', 'A']
CARD_SUITS = ['Spades', 'Clubs', 'Hearts', 'Diamonds']

# INSERT YOUR CODE AFTER THIS LINE

class Deck(object):
   '''Deck class
   '''
   def __init__(self):
     '''Create a Deck containing cards
     '''
     self.cards = []
     for token in CARD_RANKS:
       for token2 in CARD_SUITS:
         try:
           token = token.strip()
           token2 = token2.strip()
           new = Card(token, token2)
           self.cards.append(new)
           if new == None:
             raise Exception, "couldn't make a card"
         except:
           pass

   def __str__(self):
      '''return the str representation of this deck
      '''
      s_cards = [str(a) for a in self.cards]
      return '\n'.join(s_cards)

   def deal(self, num_to_deal):
      '''print out the cards to deal
      '''
      if len(self.cards) < num_to_deal:
        raise Exception("Can't deal that many")
      for counter in range(0, num_to_deal):
        print str(self.top_card())

   def top_card(self):
     try:
       return self.cards.pop()
     except:
       return ""

   def shuffle(self):
     '''shuffle the cards
     '''
     try:
       random.shuffle(self.cards)
     except:
       print "couldn't shuffle"

   def cut(self):
     '''cut the deck
     '''
     try:
       split = len(self.cards) / 2
       new_cards = []
       for counter in range(split, len(self.cards)):
         new_cards.append(self.cards[counter])
       for counter in range(0, split):
         new_cards.append(self.cards[counter])
       self.cards = new_cards
     except:
       print "couldn't cut"

   

# INSERT YOUR CODE BEFORE THIS LINE

# And here's some code to test out your implementation.  You can change this if you'd like.
if __name__ == "__main__":
  d = Deck()
  d.shuffle()

  print d
  print "dealing"
  d.deal(10)
  
  d.cut()
  print d
#  print d
