from card import Card

# You'll need the random module to shuffle the deck
import random

# Use these constant Lists to help you construct the Cards for your Deck
CARD_RANKS = ['2', '3', '4', '5', '6', '7', '8', '9', '10', 'J', 'Q', 'K', 'A']
CARD_SUITS = ['Spades', 'Clubs', 'Hearts', 'Diamonds']

# INSERT YOUR CODE AFTER THIS LINE

class Deck(object):
  '''Class Deck provides a method "add_passenger" that will add a passenger
     to the flight.  Also has a constructor and a __str__, and heaviest_passenger
     and lightest_passenger methods.
   '''
  def __init__(self):
    '''Constructor for a Deck, takes no parametesr'''
    self.cards = []
    for i in range(0, len(CARD_RANKS)):
      for j in range(0, len(CARD_SUITS)):
         c = Card(CARD_RANKS[i],CARD_SUITS[j])
         self.cards.append(c)
    return

  def __str__(self):
    '''string method'''
    o = ""
    for i in range(0, len(self.cards)):
      o = o + self.cards[i].rank + " of " + self.cards[i].suit + "\n"
    return o

  def deal(self, num_to_deal):
    '''deal num_to_deal cards out'''
    for i in range(0, num_to_deal):
      print self.cards[0]
      self.cards = self._deal(self.cards)

  def _deal(self, cards):
    '''helper method to deal the cards'''
    return cards[1:]

  def shuffle(self):
    '''shuffle the cards'''
    random.shuffle(self.cards)

  def cut(self):
    '''Cut the deck'''
    l = len(self.cards)
    o = []
    for i in range(l / 2, l):
      o.append(self.cards[i])
    for i in range(1, l / 2):
      o.append(self.cards[i])
    self.cards = o
      

  

# INSERT YOUR CODE BEFORE THIS LINE

# And here's some code to test out your implementation.  You can change this if you'd like.
if __name__ == "__main__":
  d = Deck()
  d.shuffle()

  #print d
  
  print "DEALING"
  d.deal(10)
  print "CUTTING"
  d.cut()

  print d
