from card import Card

# You'll need the random module to shuffle the deck
import random

# Use these constant Lists to help you construct the Cards for your Deck
CARD_RANKS = ['2', '3', '4', '5', '6', '7', '8', '9', '10', 'J', 'Q', 'K', 'A']
CARD_SUITS = ['Spades', 'Clubs', 'Hearts', 'Diamonds']

# INSERT YOUR CODE AFTER THIS LINE

class Deck:
  """A deck of cards'"""
  def __init__(self):
    self.cards = []
    for rank in CARD_RANKS:
      for suit in CARD_SUITS:
        card = Card(rank, suit)
        self.cards.append(card)

  def __str__(self):
    return "\n".join(["%s" % s for s in self.cards])
  
  def shuffle(self):
    random.shuffle(self.cards)

  def deal(self, num_to_deal):
    for i in range(0, num_to_deal):
      if len(self.cards) == 0:
        raise Exception("No more cards")
      card = self.cards.pop() 
      print card
      
  def cut(self):
    half = len(self.cards) / 2
    top_half = self.cards[0:half]
    bottom_half = self.cards[half:]
    bottom_half.extend(top_half)
    self.cards = bottom_half
    
    
# INSERT YOUR CODE BEFORE THIS LINE

# And here's some code to test out your implementation.  You can change this if you'd like.
if __name__ == "__main__":
  d = Deck()
  d.shuffle()

  print d
  
  d.deal(10)
  
  d.cut()

  print d
