from card import Card

# You'll need the random module to shuffle the deck
import random

# Use these constant Lists to help you construct the Cards for your Deck
CARD_RANKS = ['2', '3', '4', '5', '6', '7', '8', '9', '10', 'J', 'Q', 'K', 'A']
CARD_SUITS = ['Spades', 'Clubs', 'Hearts', 'Diamonds']

# INSERT YOUR CODE AFTER THIS LINE

class Deck(object):
  """A deck of Card objects"""
  def __init__(self):
    self.card_ranks = CARD_RANKS
    self.card_suits = CARD_SUITS
    self.deck_cards = [] #new
    for card_rank in self.card_ranks:
      for card_suit in self.card_suits:
        self.deck_cards.insert(len(self.deck_cards), Card(card_rank, card_suit))
  def __str__(self):
    out_str = ''
    for card in self.deck_cards:
      out_str+= str(card.rank) + " Of " + str(card.suit) + "\n"
    return out_str

  def deal(self, num_to_deal):
    dealt_out = 0
    # uses recusion
    while True:
      self.deck_cards = self.deal_helper(self.deck_cards, dealt_out, num_to_deal)
      return self.deck_cards
  
  def deal_helper(self, cards, dealt_out, num_to_deal):
    #base case
    if dealt_out == num_to_deal:
      return cards
    #other case
    elif dealt_out != num_to_deal:
      print str(cards[0])
      cards = cards[1:]
      dealt_out +=1 
      self.deal_helper(cards, dealt_out, num_to_deal)
    
  def shuffle(self):
    return random.shuffle(self.deck_cards)

  def cut(self):
    new_cards_2 = self.deck_cards[0:26]
    new_cards_1 = self.deck_cards[26:]
    for i in new_cards_2:
      new_cards_1.insert(len(new_cards_1),i)
    self.deck_cards = new_cards_1
    
    

# INSERT YOUR CODE BEFORE THIS LINE

# And here's some code to test out your implementation.  You can change this if you'd like.
if __name__ == "__main__":
  d = Deck()
  d.shuffle()

  print d
  
#  d.deal(10)
  
  d.cut()
  print "CUT"
  print d
